
#include "main.h"
uint8_t Card_Type1[2];
uint8_t Card_ID[4];
uint8_t User_Card[10][4] = { 0x29, 0x43, 0x1c, 0xbd, 0xb9, 0x6b, 0xff, 0xc1, 0xfa, 0x10, 0x41, 0xea }; // 
uint8_t status;
typedef struct USER {
    u8 name[10];
    u8 age[2];
    u8 sex[2];
    u8 num[14];
    u8 Id[8];
    u8 addr[30];
} USE;
enum {
    MODE_DEFAULT,
    MODE_UART,
};
enum {
    KEY_NOT_UP,
    KEY_UP,
};
enum {
    ROOT_FALSE,
    ROOT_TRUE,
};
enum {
    DOOR_CLOSE,
    DOOR_OPEN,
};
enum {
    CARD_NOTE_FIND
};

int main(void) {
    int key, i, j, n, strlen, t, p;
    float getlength;
    char id[17];
    char buff[10];
    USE User[2];
    u8 UserCard[4];
    u8 command[9];
    u8 time[16]="2022122123350003";
    int CardIndex   = CARD_NOTE_FIND;      // עῨжϼĴ
    int root        = ROOT_FALSE;      // ˢĴ
    int rootkey     = ROOT_FALSE;   // root mode־λ
    int doorstatu   = DOOR_CLOSE; // ʼ״̬Ϊر
    int mode        = MODE_DEFAULT;      // ʼģʽΪ⿨ģʽ
    int action = 0;    // ڳʼģʽΪģʽ
    int Len = 0;
    Card_Type1[0] = 0x04;
    Card_Type1[1] = 0x00;

    delay_init();                                   // ʱʼ
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2); // NVICжϷ2:2λռȼ2λӦȼ
    uart_init(115200);                              // ڳʼΪ115200
    printf("\r\n****SERIAL PORT TEST****\r\n");

    DS1302_Init();
    SystemInit(); // System init.
    delay_init();
    RC522_IO_Init();
    BEEP_Init();
    LED_Init();
    DIANJI_Init();
    KEY_Init();
    Hcsr05Init();
    Lcd_Init();
    W25QXX_Init(); // W25QXXʼ
    // W25QXX_Erase_Chip();//Ƭ
    // Change_SaveNumB(1,0);//־
    LCD_BL_SET;
    LCD_CS_CLR;
    showimageALL(gImage_2);
    delay_ms(1000);
    Lcd_Clear(WHITE);
    Len = R_SaveNumC();

    //DS1302_ChangeTime(time);

    PcdReset();      // λRC522
    PcdAntennaOff(); // ر
    delay_ms(100);
    PcdAntennaOn(); // 
    // doorstatu=Door_control(0);
    printf("\r\n****HJT SERIAL PORT TEST****\r\n");

    Usermessage_Add(0, "ROOT", "NU", "NU", "NULL", User_Card[0], "NULL");
    sprintf(buff, "USER:%d LOG:%d\n", R_SaveNumA(), R_SaveNumB());
    Gui_DrawFont_GBK16(0, 64, BLUE, WHITE, (u8*)buff);

    while (1) {
        key = KEY_Scan(0);
        if (mode == MODE_DEFAULT) {
            if (rootkey == ROOT_FALSE)
                Gui_DrawFont_GBK16(144, 00, BLACK, WBLUE, "  ");
            getlength = Hcsr05GetLength(); // õ
            if (getlength <= Len) {
                if (doorstatu == DOOR_CLOSE) {
                    LED1_OUT(0);
                    BEEP_OUT(0);
                }
                if (doorstatu == DOOR_OPEN) {
                    LED2_OUT(1);
                    BEEP_once();
                    doorstatu = Door_control(DOOR_CLOSE);
                    root = 0;
                    rootkey = ROOT_FALSE;
                }
            }
            if (getlength > 600)
                getlength = -1;

            DS1302_GetTime();
            sprintf(buff, "%3.0f", getlength);
            Gui_DrawFont_GBK16(132, 64, BLUE, WHITE, (u8*)buff); // Ļӡ

            key = KEY_Scan(0);
            delay_ms(10);
            if (MI_OK == PcdRequest(0x26, Card_Type1)) // ѰɹMI_OK  ӡһο
            {
                status = PcdAnticoll(Card_ID); // ײ ɹMI_OK
                if (status != MI_OK) {
                    // printf("Anticoll Error\r\n");
                } else {
                    sprintf(id, "ID:%02X%02X%02X%02X  ", Card_ID[0], Card_ID[1], Card_ID[2], Card_ID[3]); // ȡ
                    Gui_DrawFont_GBK16(16, 16, BLUE, WHITE, (u8*)id);
                    for (i = 0; i < R_SaveNumA(); i++) // пԱ
                    {
                        GetUserID(i, UserCard);
                        for (j = 0; j < 4; j++) {
                            if (Card_ID[j] == UserCard[j])
                                CardIndex = i + 1; // flagԶȡ
                            else
                                CardIndex = CARD_NOTE_FIND;
                            break;
                        }
                        if (CardIndex != CARD_NOTE_FIND) // flag0жǷȻ
                        {
                            if (i == 0)
                                root = root + 1; // ICǷΪ
                            if (i != 0)
                                root = 0;
                            break;
                        }
                    }

                    status = PcdSelect(Card_ID); // ѡ ɹMI_OK
                    if (status != MI_OK) {
                        printf("Select Card Error\r\n");
                    } else {
                        BEEP_once(); // һ
                    }

                    if (root >= 2) // ˢΣԱģʽ
                    {
                        rootkey = ROOT_TRUE;
                        Gui_DrawFont_GBK16(144, 00, WHITE, BLACK, "");//  Ϊ rootlog ͼƬ
                    }

                    status = PcdHalt(); // Ƭ״ֹ̬ظ
                    if (status != MI_OK) {
                        printf("PcdHalt Error\r\n");
                    } else {
                        if (rootkey == ROOT_TRUE) // Ѿrootģʽ
                        {
                            if (CardIndex != CARD_NOTE_FIND && CardIndex != 1) // ڿУҲ
                            {
                                n = CardIndex - 1; // õţҲб
                                DelUser(n);              // ɾûϢ
                                sprintf(buff, "USER:%d LOG:%d\n", R_SaveNumA(), R_SaveNumB());
                                Gui_DrawFont_GBK16(0, 64, BLUE, WHITE, (u8*)buff);
                                rootkey = ROOT_FALSE;
                                Gui_DrawFont_GBK16(0, 32, BLACK, WHITE, "DEL  ");
                            } else if (CardIndex == CARD_NOTE_FIND) // ڿ
                            {
                                AddUser(Card_ID); // һֻпŵûϢ
                                sprintf(buff, "USER:%d LOG:%d\n", R_SaveNumA(), R_SaveNumB());
                                Gui_DrawFont_GBK16(0, 64, BLUE, WHITE, (u8*)buff);
                                rootkey = ROOT_FALSE;
                                Gui_DrawFont_GBK16(0, 32, BLACK, WHITE, "ADD  ");
                            }
                        } else {
                            if (CardIndex != CARD_NOTE_FIND) // ⿨Ƿȷ
                            {
                                Gui_DrawFont_GBK16(0, 16, BLUE, WHITE, "");
                                Log_save(CardIndex);
                                sprintf(buff, "USER:%d LOG:%d\n", R_SaveNumA(), R_SaveNumB());
                                Gui_DrawFont_GBK16(0, 64, BLUE, WHITE, (u8*)buff);
                                LED1_OUT(1);
                                BEEP_OUT(1);
                                if (doorstatu == DOOR_CLOSE) {
                                    LED2_OUT(0);
                                    doorstatu = Door_control(DOOR_OPEN);
                                }
                            } else {
                                Gui_DrawFont_GBK16(0, 16, RED, WHITE, "");
                                if (doorstatu == DOOR_OPEN) {
                                    LED2_OUT(1);
                                    doorstatu = Door_control(DOOR_OPEN);
                                }
                            }
                        }
                    }
                }
            }
        }
        if (mode == MODE_UART) {
            if (USART_RX_STA & 0x8000 && action == 0) {
                strlen = USART_RX_STA & 0x3f; // õ˴νյݳ
                if (strlen > 9 | strlen < 9) {
                    printf("ȷ...\n");
                    USART_RX_STA = 0;
                } else {
                    printf("\r\n Your message is:\r\n\r\n");
                    for (t = 0; t < 9; t++) {
                        USART_SendData(USART1, USART_RX_BUF[t]);
                        // 򴮿 1 
                        command[t] = USART_RX_BUF[t];
                        while (USART_GetFlagStatus(USART1, USART_FLAG_TC) != SET)
                            ; // ȴ//ͽ
                    }
                    printf("\r\n\r\n"); // 뻻

                    if (strcmp((const char*)command, "HELP11111") == 0) {
                        printf("CHANGEMES:޸ûϢ\n"); // 
                        printf("CHANGELEN:޸ļֵ\n");
                        printf("RETURNUSE:ûϢ\n");
                        printf("CLEARUSE1:ûϢ\n");
                        printf("RETURNLOG:־\n");
                        printf("CLEARLOG1:־\n");
                        printf("CHANGETIM:޸ʱ\n");
                        printf("OPENDOOR1:\n");
                        printf("CLOSEDOOR:\n");
                        printf("ESC111111:˳ģʽ\n");
                        printf("END...\n:\n");
                    } else if (strcmp((const char*)command, "CHANGEMES") == 0) {
                        action = 1; // ޸ûϢ
                        UserMessage_display();
                        printf("Ҫ޸ĵû:\n");
                        USART_RX_STA = 0;
                    } else if (strcmp((const char*)command, "CHANGELEN") == 0) {
                        action = 7; // ޸ļֵ
                        printf("ǰֵΪ: %d\n", R_SaveNumC());
                        printf("޸ĺļֵ:\n");
                        USART_RX_STA = 0;
                    } else if (strcmp((const char*)command, "CLEARLOG1") == 0) {
                        Change_SaveNumB(1, 0);
                        printf("־...\n:\n"); // ־
                        sprintf(buff, "USER:%d LOG:%d\n", R_SaveNumA(), R_SaveNumB());
                        Gui_DrawFont_GBK16(0, 64, WHITE, BLACK, (u8*)buff);
                    } else if (strcmp((const char*)command, "CLEARUSE1") == 0) {
                        Change_SaveNumA(1, 1);
                        printf("ûϢ...\n:\n"); // ־
                        sprintf(buff, "USER:%d LOG:%d\n", R_SaveNumA(), R_SaveNumB());
                        Gui_DrawFont_GBK16(0, 64, WHITE, BLACK, (u8*)buff);
                    } else if (strcmp((const char*)command, "CHANGETIM") == 0) {
                        action = 8; // ޸ʱ
                        printf("ʱ(ʵ:2020010112000001):\n");
                        USART_RX_STA = 0;
                    } else if (strcmp((const char*)command, "OPENDOOR1") == 0) {
                        if (doorstatu == DOOR_CLOSE)
                            doorstatu = Door_control(DOOR_OPEN);
                        USART_RX_STA = 0;
                        printf("ִϣ\n:\n");
                    } // 
                    else if (strcmp((const char*)command, "CLOSEDOOR") == 0) {
                        if (doorstatu == DOOR_OPEN)
                            doorstatu = Door_control(DOOR_CLOSE);
                        USART_RX_STA = 0;
                        printf("ִϣ\n:\n");
                    } // 
                    else if (strcmp((const char*)command, "ESC111111") == 0) {
                        mode = 0;
                        printf("˳ģʽ:\n");
                        rootkey = ROOT_FALSE;
                        Lcd_Clear(WHITE);
                        sprintf(buff, "USER:%d LOG:%d\r\n", R_SaveNumA(), R_SaveNumB());
                        Gui_DrawFont_GBK16(0, 64, BLUE, WHITE, (u8*)buff);
                        USART_RX_STA = 0;
                    } // ˳ڵģʽ
                    else if (strcmp((const char*)command, "RETURNLOG") == 0) {
                        Log_display();
                        USART_RX_STA = 0;
                        printf(":\n");
                    } // ־
                    else if (strcmp((const char*)command, "RETURNUSE") == 0) {
                        UserMessage_display();
                        USART_RX_STA = 0;
                        printf(":\n");
                    } // ûϢ
                    else if (strcmp((const char*)command, "SHOWMYJPG") == 0) {
                        showimageALL(gImage_2);
                        printf(":\n");
                    } // ûϢ

                    else {
                        printf("Ҳ...\n");
                        USART_RX_STA = 0;
                    }
                    USART_RX_STA = 0;
                }
            }

            else if (USART_RX_STA & 0x8000 && action == 1) {
                strlen = USART_RX_STA & 0x3f;
                printf("\r\n ûΪ:");
                for (t = 0; t < strlen; t++) {
                    USART_SendData(USART1, USART_RX_BUF[t]);
                    while (USART_GetFlagStatus(USART1, USART_FLAG_TC) != SET)
                        ;
                }
                p = atoi((char*)USART_RX_BUF);
                printf("\n");
                if (p >= R_SaveNumA()) {
                    printf("\n:\n");
                    action = 1;
                    USART_RX_STA = 0;
                } else {
                    action = 2;
                    USART_RX_STA = 0;
                    printf("û:\n");
                }
            } else if (USART_RX_STA & 0x8000 && action == 2) {
                strlen = USART_RX_STA & 0x3f;
                printf("\r\n ûΪ:\n");
                for (t = 0; t < strlen; t++) {
                    User[0].name[t] = USART_RX_BUF[t];
                    USART_SendData(USART1, USART_RX_BUF[t]);
                    while (USART_GetFlagStatus(USART1, USART_FLAG_TC) != SET)
                        ;
                }
                printf("\n");
                action = 3;
                USART_RX_STA = 0;
                printf("ûԱ:\n");
                action = 3;
                USART_RX_STA = 0;
            } else if (USART_RX_STA & 0x8000 && action == 3) {
                strlen = USART_RX_STA & 0x3f;
                printf("\r\n ûԱΪ:\n");
                for (t = 0; t < strlen; t++) {
                    User[0].sex[t] = USART_RX_BUF[t];
                    USART_SendData(USART1, USART_RX_BUF[t]);
                    while (USART_GetFlagStatus(USART1, USART_FLAG_TC) != SET)
                        ;
                }
                printf("\n");
                action = 3;
                USART_RX_STA = 0;
                printf("û:\n");
                action = 4;
                USART_RX_STA = 0;
            } else if (USART_RX_STA & 0x8000 && action == 4) {
                strlen = USART_RX_STA & 0x3f;
                printf("\r\n ûΪ:\n");
                for (t = 0; t < strlen; t++) {
                    User[0].age[t] = USART_RX_BUF[t];
                    USART_SendData(USART1, USART_RX_BUF[t]);
                    while (USART_GetFlagStatus(USART1, USART_FLAG_TC) != SET)
                        ;
                }
                printf("\n");
                action = 3;
                USART_RX_STA = 0;
                printf("û绰:\n");
                action = 5;
                USART_RX_STA = 0;
            } else if (USART_RX_STA & 0x8000 && action == 5) {
                strlen = USART_RX_STA & 0x3f;
                printf("\r\n û绰Ϊ:\n");
                for (t = 0; t < strlen; t++) {
                    User[0].num[t] = USART_RX_BUF[t];
                    USART_SendData(USART1, USART_RX_BUF[t]);
                    while (USART_GetFlagStatus(USART1, USART_FLAG_TC) != SET)
                        ;
                }
                printf("\n");
                action = 3;
                USART_RX_STA = 0;
                printf("ûסַ:\n");
                action = 6;
                USART_RX_STA = 0;
            } else if (USART_RX_STA & 0x8000 && action == 6) {
                strlen = USART_RX_STA & 0x3f;
                printf("\r\n ûסַΪ:\n");
                for (t = 0; t < strlen; t++) {
                    User[0].addr[t] = USART_RX_BUF[t];
                    USART_SendData(USART1, USART_RX_BUF[t]);
                    while (USART_GetFlagStatus(USART1, USART_FLAG_TC) != SET)
                        ;
                }
                printf("\n");
                GetUserID(p, User_Card[4]);
                Usermessage_Add(p, User[0].name, User[0].age, User[0].sex, User[0].num, User_Card[4], User[0].addr);
                printf("-----------Ϣ¼--------\n:\n");
                action = 0;
                USART_RX_STA = 0;
            } else if (USART_RX_STA & 0x8000 && action == 7) {
                strlen = USART_RX_STA & 0x3f;
                printf("\r\n ļֵΪ:\n");
                for (t = 0; t < strlen; t++) {
                    USART_SendData(USART1, USART_RX_BUF[t]);
                    while (USART_GetFlagStatus(USART1, USART_FLAG_TC) != SET)
                        ;
                }
                p = atoi((char*)USART_RX_BUF);
                printf("\n");
                if (p >= 750) {
                    printf("ֵ\nֵ(MAX=750):\n");
                    action = 7;
                    USART_RX_STA = 0;
                } else {
                    Change_SaveNumC(1, p);
                    Len = R_SaveNumC();
                    action = 0;
                    USART_RX_STA = 0;
                    printf("-----------ֵ޸--------\n:\n");
                }
            } else if (USART_RX_STA & 0x8000 && action == 8) {
                strlen = USART_RX_STA & 0x3f;
                printf("\r\n ʱΪ:\n");
                for (t = 0; t < strlen; t++) {
                    USART_SendData(USART1, USART_RX_BUF[t]);
                    while (USART_GetFlagStatus(USART1, USART_FLAG_TC) != SET)
                        ;
                }
                DS1302_ChangeTime(USART_RX_BUF);
                printf("\n");
                action = 0;
                USART_RX_STA = 0;
                printf("-----------ʱ޸--------\n:\n");
            } else {
                LED1_OUT(1);
                LED2_OUT(0);
            }
        }

        if (key == KEY_UP) {
            root = 0;
            BEEP_once();

            if (rootkey == ROOT_TRUE & mode == MODE_DEFAULT) // rootģʽ
            {
                Lcd_Clear(WHITE);
                showimage1(gImage_3, 40, 0, 120, 45);
                mode = 1; // 봮ڵģʽ

                Gui_DrawFont_GBK16(0, 48, BLACK, WHITE, "*ѽ봮ģʽ*");
                Gui_DrawFont_GBK16(0, 64, BLACK, WHITE, "*ڴλ*");
                printf("ѽ봮ڵģʽ......\n");
            } else if (mode == MODE_DEFAULT) {
                LED1_OUT(1);
                LED2_OUT(0);
                Log_display();
                Gui_DrawFont_GBK16(0, 64, BLUE, WHITE, "LOG Send OK! ");
            } else if (mode == MODE_UART) {
                mode = MODE_DEFAULT;
                rootkey = ROOT_FALSE;
                Lcd_Clear(WHITE);
                sprintf(buff, "USER:%d LOG:%d\r\n", R_SaveNumA(), R_SaveNumB());
                Gui_DrawFont_GBK16(0, 64, BLUE, WHITE, (u8*)buff);
            }
        }
    }
}
